	<?php
		
		function get_rank_info($data) {
			
			$results = array();
			
			if (!empty($data)) {
				
				require_once('simple_html_dom.php');
				
				$errors = array();
				
				if (!empty($data['own_domains'])) {
					$data['own_domains'] = parse_domain_names($data['own_domains']);
				}
				
				if (!empty($data['other_domains'])) {
					$data['other_domains'] = parse_domain_names($data['other_domains']);
				}
				
				if (empty($data['keyword'])) {
					$errors[] = 'Please enter keyword';
				}
				
				if (empty($data['other_domains']) && empty($data['own_domains'])) {
					$errors[] = 'Please enter your domains or competitor domains';
				}
				
				if (!empty($errors)) {
					return array('errors' => $errors);
				}
				
				$keyword = str_replace(' ', '+', $data['keyword']);
				
				
				$start = $data['start'];
				
				$rank = $start;
				
				$url  = 'http://www.google.com/search?q=' . $keyword . '&num=100&start=' . $start;
				$html = file_get_html($url);
				
				//echo $url . '<br />';
					
				//Going through all records
				if (!empty($html)) {
					$lis = $html->find('li.g');
				}
					
				if (!empty($lis)) {
					
					foreach ($lis as $li) {
						
						$rank ++;
						
						//Link Data
						$link_obj = $li->find('h3.r a', 0);					
						$title = trim($link_obj->plaintext);
						$link  = trim($link_obj->href);
						
						//short Description
						$desc = trim($li->find('span.st', 0)->plaintext);
						
						//parsing Url
						if (!preg_match('/^https?/', $link) && preg_match('/q=(.+)&amp;sa=/U', $link, $matches) && preg_match('/^https?/', $matches[1])) {
							$link = $matches[1];
						} else if (!preg_match('/^https?/', $link)) { // skip if it is not a valid link
							continue;
						}
						
						$parse = parse_url($link);
						$domain = get_domain_name($parse['host']);
						
						$site_info = array(
							'link'		=>	$link,
							'title'		=>	htmlentities($title),
							'desc'		=>	htmlentities($desc),
							'rank'		=>	$rank,
							'domain'	=>  $domain
						);
						
						//echo $domain . '<br />';
						//echo '<pre>'; var_export($data['own_domains']); echo '</pre>';
						//echo '<pre>'; var_export($data['other_domains']); echo '</pre>';
						
						if (!empty($data['own_domains']) && in_array($domain, $data['own_domains'])) {
							$site_info['type'] = 'own_domain';
							$results[] = $site_info;
						}
						
						if (!empty($data['other_domains']) && in_array($domain, $data['other_domains'])) {
							$site_info['type'] = 'other_domain';
							$results[] = $site_info;
						}
				
					}
					
				}
					$start = $start + 100;	
				//}
			}
			
			//echo '<pre>'; var_export($results);
			
			return array('rank_info' => $results);
		}
		
		
		function get_domain_name($url) {
			
			$array_search = array('https://', 'http://', 'www.');
			$array_replace = array('', '', '');
			
			$url = str_replace($array_search, $array_replace, $url);
			
			if (substr($url, strlen($url) - 1, strlen($url)) == '/') {
				$url = substr($url, 0, strlen($url) - 1);
			}
			
			return 'www.' . $url;

		}
		
		function parse_domain_names($domains) {
			
			$_domains = array();
			
			if (!empty($domains)) {
				
				foreach ($domains as $domain) {
					$_domains[] = get_domain_name($domain);
				}
			}
			
			return $_domains;
			
		}
		
	?>